import javax.swing.*;
import java.awt.*;

public class ChatRoomGUI extends JFrame implements NewMessageListener{
    private final String WINDOWS_TITLE = "AUT Chat Room";
    private final int WIDTH = 500, HEIGHT = 500;
    private final int X = 100, Y = 100;
    ChatArea chatArea;
    MessageArea messageArea;
    ParticipantsArea participantsArea;
    String username;

    public ChatRoomGUI() {
        super();
        this.setLayout(new BorderLayout());
        this.setTitle(WINDOWS_TITLE);
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setSize(WIDTH, HEIGHT);
        this.setLocation(X, Y);
        chatArea = new ChatArea();
        this.add(new JScrollPane(chatArea), BorderLayout.CENTER);
        messageArea = new MessageArea(this);
        this.add(messageArea, BorderLayout.PAGE_END);
        participantsArea = new ParticipantsArea();
        this.add(new JScrollPane(participantsArea), BorderLayout.WEST);
        this.setVisible(true);
    }

    public void addNewMessage(String name, String message)
    {
        this.chatArea.addMessage(name, message);
    }

    public void addNewParticipant(String name)
    {
        this.participantsArea.addNewParticipant(name);
    }

    public void removeNewParticipant(String name)
    {
        this.participantsArea.removeParticipant(name);
    }

    public void addNewMessageListener(String name, String message)
    {
        this.chatArea.addMessage(name, message);
    }

    public void addNewParticipantListener(String name) {this.participantsArea.addNewParticipant(name);}
}
